<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPositionItemResult_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPositionItemResult_V3 extends AbstractStructArrayBase
{
    /**
     * The PositionItemResult_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PositionItemResult_V3[]
     */
    public $PositionItemResult_V3;
    /**
     * Constructor method for ArrayOfPositionItemResult_V3
     * @uses ArrayOfPositionItemResult_V3::setPositionItemResult_V3()
     * @param \StructType\PositionItemResult_V3[] $positionItemResult_V3
     */
    public function __construct(array $positionItemResult_V3 = array())
    {
        $this
            ->setPositionItemResult_V3($positionItemResult_V3);
    }
    /**
     * Get PositionItemResult_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PositionItemResult_V3[]|null
     */
    public function getPositionItemResult_V3()
    {
        return isset($this->PositionItemResult_V3) ? $this->PositionItemResult_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPositionItemResult_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPositionItemResult_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePositionItemResult_V3ForArrayConstraintsFromSetPositionItemResult_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPositionItemResult_V3PositionItemResult_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfPositionItemResult_V3PositionItemResult_V3Item instanceof \StructType\PositionItemResult_V3) {
                $invalidValues[] = is_object($arrayOfPositionItemResult_V3PositionItemResult_V3Item) ? get_class($arrayOfPositionItemResult_V3PositionItemResult_V3Item) : sprintf('%s(%s)', gettype($arrayOfPositionItemResult_V3PositionItemResult_V3Item), var_export($arrayOfPositionItemResult_V3PositionItemResult_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PositionItemResult_V3 property can only contain items of type \StructType\PositionItemResult_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PositionItemResult_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PositionItemResult_V3[] $positionItemResult_V3
     * @return \ArrayType\ArrayOfPositionItemResult_V3
     */
    public function setPositionItemResult_V3(array $positionItemResult_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($positionItemResult_V3ArrayErrorMessage = self::validatePositionItemResult_V3ForArrayConstraintsFromSetPositionItemResult_V3($positionItemResult_V3))) {
            throw new \InvalidArgumentException($positionItemResult_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($positionItemResult_V3) || (is_array($positionItemResult_V3) && empty($positionItemResult_V3))) {
            unset($this->PositionItemResult_V3);
        } else {
            $this->PositionItemResult_V3 = $positionItemResult_V3;
        }
        return $this;
    }
    /**
     * Add item to PositionItemResult_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\PositionItemResult_V3 $item
     * @return \ArrayType\ArrayOfPositionItemResult_V3
     */
    public function addToPositionItemResult_V3(\StructType\PositionItemResult_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PositionItemResult_V3) {
            throw new \InvalidArgumentException(sprintf('The PositionItemResult_V3 property can only contain items of type \StructType\PositionItemResult_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PositionItemResult_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PositionItemResult_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PositionItemResult_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PositionItemResult_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PositionItemResult_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PositionItemResult_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PositionItemResult_V3
     */
    public function getAttributeName()
    {
        return 'PositionItemResult_V3';
    }
}
